if select(2, UnitClass("player")) ~= "DEATHKNIGHT" then
   return
end

------------------------------------------------------------------------

ThreeRuneBars = CreateFrame("frame", nil, UIParent);

function ThreeRuneBars:init()
	self.isLocked = true;

	self:RegisterEvent("ADDON_LOADED");

	self:SetScript("OnEvent", function(frame, event, ...) frame[event](frame, ...); end );
	
end

function ThreeRuneBars:Unlock()
	DEFAULT_CHAT_FRAME:AddMessage("ThreeRuneBars Unlocked");
	self.isLocked = false;
	
	for name, m in pairs(self.modules) do
		if( m.moveFrame ) then
			m.moveFrame:Show();
		end
	end
end

function ThreeRuneBars:Lock()
	DEFAULT_CHAT_FRAME:AddMessage("ThreeRuneBars Locked");
	self.isLocked = true;
	for name, m in pairs(self.modules) do
		if( m.moveFrame ) then
			m.moveFrame:Hide();
		end
	end
end

function ThreeRuneBars:RegisterModule(name, m)

	if( not self.modules ) then self.modules = {}; end
	
	if( not self.modules[name]) then 
		self.modules[name] = m;
	else
		DEFAULT_CHAT_FRAME:AddMessage("UT: Module "..name.." already registered");
	end
end

function ThreeRuneBars:ADDON_LOADED(addon)
	if( addon == "ThreeRuneBars" and (select(2, UnitClass("player")) == "DEATHKNIGHT")) then
		DEFAULT_CHAT_FRAME:AddMessage("ThreeRuneBars loaded");
		
		if( not TRB_Config.Colors or not TRB_Config.Positions or not TRB_Config.disabled_modules) then 
			DEFAULT_CHAT_FRAME:AddMessage("TRB: Default config loaded.");
			
			if(not TRB_Config.Colors) then
				TRB_Config.Colors = TRB_Config_Defaults.Colors; 
			end
			
			if (not TRB_Config.Positions ) then
				TRB_Config.Positions = TRB_Config_Defaults.Positions; 
			end
			
			if (not TRB_Config.disabled_modules) then
				TRB_Config.disabled_modules = TRB_Config_Defaults.disabled_modules; 
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("TRB: User config loaded.");
		end
		
		for name, m in pairs(self.modules) do
			if( TRB_Config["disabled_modules"][name] == false ) then
				DEFAULT_CHAT_FRAME:AddMessage("ThreeRuneBars loading module: "..name);
				m:init();
			end
		end
	end
end

-- Start Addon
ThreeRuneBars:init();

SLASH_TRB1, SLASH_TRB2 = "/trb", "/ThreeRuneBars";

local function TRB_SlashHandler(msg, editbox)

	if( msg == "diseases" ) then
		if(TRB_Config["disabled_modules"]["Diseases"] == true) then
			DEFAULT_CHAT_FRAME:AddMessage("ThreeRuneBars disable Diseases module.");
			TRB_Config["disabled_modules"]["Diseases"] = false;
			ThreeRuneBars.modules["Diseases"]:Disable();
		else
			DEFAULT_CHAT_FRAME:AddMessage("ThreeRuneBars enable Diseases module.");
			TRB_Config["disabled_modules"]["Diseases"] = true;
			ThreeRuneBars.modules["Diseases"]:init();
		end
		
		return;
	end

	if( ThreeRuneBars.isLocked ) then
		ThreeRuneBars:Unlock();
	else
		ThreeRuneBars:Lock();
	end

end
SlashCmdList["TRB"] = TRB_SlashHandler;
